from abc import ABC, abstractmethod


class ModuleABC(ABC):

    @abstractmethod
    def __init__(self):
        self._priorities = {}
        self._success = True

    def get_priority(self, t: type) -> int:
        if t not in self._priorities:
            raise Exception(f'Priority for {t} not found!')
        return self._priorities[t]

    def stop_propagation(self):
        self._success = False

    @property
    def success(self) -> bool:
        return self._success
